//******************************* TCO() ******************************
class TCO {
    Pave paves[][]              = new Pave[2*c_max][2*l_max];
    boolean  presence_pave_occupe = false;
    //------------------------------------ dessine_tco_debut() -------------------------------------------
    void dessine_tco_debut() {
        for (Pave pave : tous_paves) {
            if (pave.l <= L_MAX) {
                if (pave.type != 12) {                                                                                                    //  pas pont tournant...
                    niveau            = 0;
                    bordure_x         = int(BORDURE_X+MAILLE*zoom_x/2+.5);
                    bordure_y         = int(BORDURE_Y+MAILLE*zoom_y/2+.5);
                    dessine_pave_du_tco_debut(pave);                                                                                      //  ...donc un pavé normal
                } else {                                                                                                                  //  On dessinera le pont tournant dans un deuxieme temps. On memorise ici ses coordonnées.
                    pavePont = pave;
                }
            }
        }
        for (Pave pave : tous_paves) {
            if (pave.l > L_MAX) {
                if (pave.type != 12) {                                                                                                    //  pas pont tournant...
                    niveau            = 1;
                    bordure_x         = BORDURE_X;
                    bordure_y         = BORDURE_Y;
                    dessine_pave_du_tco_debut(pave);                                                                                      //  ...donc un pavé normal
                } else {                                                                                                                  //  on dessinera le pont tournant dans un deuxieme temps. On memorise ici ses coordonnées.
                    pavePont = pave;
                }
            }
        }
        //---------------------------------------- pont tournant ---------------------------------         
                                                                                                                                          //  on dessine le pont tournant dans un deuxieme temps pour qu'elle soit toujours au dessus                                                              
                                                                                                                                          //  (c'est necessaire parce que la cabine du pont depasse des rails de la fosse)
        if (pavePont != null) {                                                                                        
            if (pont_tournant_pose && etiquettes_pont) {
                int total_voies = int(pave.ordre);         //  24 -> 24    32 -> 32    40 ->  40    48  ->  48
                int valeur1     = total_voies/4;           //  24 ->  6    32 ->  8    40 ->  10    48  ->  12
                int valeur2     = total_voies/8;           //  24 ->  3    32 ->  4    40 ->   5    48  ->   6
                int valeur3     = total_voies+1-valeur2;   //  24 -> 22    32 -> 29    40 ->  36    48  ->  43
                int valeur4     = valeur1+valeur2;         //  24 ->  9    32 -> 12    40 ->  15    48  ->  18
                int valeur5     = valeur1+valeur4+1;       //  24 -> 16    32 -> 21    40 ->  26    48  ->  31
                for (int i = 0; i < valeur1; i++) {
                    dessine_label(0, (valeur3+i) % total_voies, c_pont+valeur2, l_pont+valeur2-1-i);
                    if (i == (valeur2-1)) {
                        dessine_label(0, total_voies, c_pont+valeur2, l_pont);                            
                    }
                    dessine_label(0, valeur4-i,   c_pont-valeur2+i,   l_pont-valeur2);
                    dessine_label(0, valeur4+1+i, c_pont-valeur2,     l_pont-valeur2+1+i);
                    dessine_label(0, valeur5+i,   c_pont-valeur2+1+i, l_pont+valeur2);
                }
            }
            dessine_pave_du_tco(pavePont);
        }
    }
    //------------------------------------ dessine_tco() -------------------------------------------
    void dessine_tco() {
        for (Pave pave : tous_paves) {                                                          
            if (pave.l <= L_MAX) {
                if (pave.type != 12) {                                                                                                    //  pas pont tournant...
                    niveau           = 0;
                    bordure_x        = int(BORDURE_X+MAILLE*zoom_x/2+.5);
                    bordure_y        = int(BORDURE_Y+MAILLE*zoom_y/2+.5);
                    dessine_pave_du_tco(pave);                                                                                            //  ...donc un pavé normal
                } else {                                                                                                                  //  on dessinera le pont tournant dans un deuxieme temps. On memorise ici ses coordonnées.
                    pavePont = pave;
                }
            }
        }
        for (Pave pave : tous_paves) {
            if (pave.l > L_MAX) {
                if (pave.type != 12) {                                                                                                    //  pas pont tournant...
                    niveau           = 1;
                    bordure_x        = BORDURE_X;
                    bordure_y        = BORDURE_Y;
                    dessine_pave_du_tco(pave);                                                                                            //  ...donc un pavé normal
                } else {                                                                                                                  //  on dessinera le pont tournant dans un deuxieme temps. On memorise ici ses coordonnées.
                    pavePont = pave;
                }
            }
        }
        //---------------------------------------- pont tournant ---------------------------------         
                                                                                                                                          //  on dessine le pont tournant dans un deuxieme temps pour qu'elle soit toujours au dessus                                                              
                                                                                                                                          //  (c'est necessaire parce que la cabine du pont depasse des rails de la fosse)
        if (pavePont != null) {                                                                                        
            if (pont_tournant_pose && etiquettes_pont) {
                int total_voies = int(pave.ordre);         //  24 -> 24    32 -> 32    40 ->  40    48  ->  48
                int valeur1     = total_voies/4;           //  24 ->  6    32 ->  8    40 ->  10    48  ->  12
                int valeur2     = total_voies/8;           //  24 ->  3    32 ->  4    40 ->   5    48  ->   6
                int valeur3     = total_voies+1-valeur2;   //  24 -> 22    32 -> 29    40 ->  36    48  ->  43
                int valeur4     = valeur1+valeur2;         //  24 ->  9    32 -> 12    40 ->  15    48  ->  18
                int valeur5     = valeur1+valeur4+1;       //  24 -> 16    32 -> 21    40 ->  26    48  ->  31
                for (int i = 0; i < valeur1; i++) {
                    dessine_label(0, (valeur3+i) % total_voies, c_pont+valeur2, l_pont+valeur2-1-i);
                    if (i == (valeur2-1)) {
                        dessine_label(0, total_voies, c_pont+valeur2, l_pont);                            
                    }
                    dessine_label(0, valeur4-i,   c_pont-valeur2+i,   l_pont-valeur2);
                    dessine_label(0, valeur4+1+i, c_pont-valeur2,     l_pont-valeur2+1+i);
                    dessine_label(0, valeur5+i,   c_pont-valeur2+1+i, l_pont+valeur2);
                }
            }
            dessine_pave_du_tco(pavePont);
        }
    }    
    //------------------------------------ dessine_feux_tco() -------------------------------------------
    void dessine_feux_tco() {
        for (Pave pave : tous_signaux) {
            if (pave.type != 12) {                                                                                                        //  pas pont tournant...
                bordure_x = int(BORDURE_X+MAILLE*zoom_x/2+.5);
                bordure_y = int(BORDURE_Y+MAILLE*zoom_y/2+.5);
                niveau    = 0;
                dessine_feu_pave_du_tco(pave);
            } else {                                                                                                                      //  on dessinera le pont tournant dans un deuxieme temps. On memorise ici ses coordonnées.
                pavePont = pave;
            }
        }
        for (Pave pave : tous_signaux) {
            if (pave.type != 12) {                                                                                                        //  pas pont tournant...
                bordure_x = BORDURE_X;
                bordure_y = BORDURE_Y;
                niveau    = 1;                                                                                                            //  ...donc un pavé normal
                dessine_feu_pave_du_tco(pave);
            } else {                                                                                                                      //  On dessinera le pont tournant dans un deuxieme temps. On memorise ici ses coordonnées.
                pavePont = pave;
            }
        }
    }    
    //---------------------------- dessine_pave_du_tco_debut() -----------------------------------------
    void dessine_pave_du_tco_debut(Pave _pave) {
        pushMatrix();
            translate(bordure_x+(_pave.c+c_min)*MAILLE*zoom_x, bordure_y+(_pave.l+l_min-niveau*l_max)*MAILLE*zoom_y);
            scale(zoom_x, zoom_y);
            _pave.dessine_pave_debut(_pave.c, _pave.l);
            //largeur_vehicule  = 2F*RAIL*zoom_x;
            //longueur_vehicule = largeur_vehicule;
        popMatrix();
    }    
    //---------------------------- dessine_pave_du_tco() -----------------------------------------
    void dessine_pave_du_tco(Pave _pave) {
        pushMatrix();
            translate(bordure_x+(_pave.c+c_min)*MAILLE*zoom_x, bordure_y+(_pave.l+l_min-niveau*l_max)*MAILLE*zoom_y);
            scale(zoom_x, zoom_y);
            _pave.dessine_pave();
        popMatrix();
    }    
    //---------------------------- dessine_feu_pave_du_tco() -----------------------------------------
    void dessine_feu_pave_du_tco(Pave _pave) {
        pushMatrix();
            translate(bordure_x+(_pave.c+c_min)*MAILLE*zoom_x, bordure_y+(_pave.l+l_min-niveau*l_max)*MAILLE*zoom_y);                     //  il n'y a pas de mise à l'échelle : ralentit trop le processus (2ms par feu !) )
            _pave.dessine_feu_pave(0);
            _pave.dessine_feu_pave(1);
        popMatrix();
    }    
    //------------------------------- dessine_label() ------------------------------------
    void dessine_label(int _type_l, int _label_c, int _c, int _l) {                                                                                 // dessine le label dans un pave
        textSize(3*zoom_y);
        if (_label_c != 0) {
            fill(BLANC);
            stroke(NOIR);
            int c_pave = int(bordure_x+(_c+c_min)*MAILLE*zoom_x);
            int l_pave = int(bordure_y+(_l+l_min)*MAILLE*zoom_y-niveau*l_max*MAILLE*zoom_y);

            textAlign(CENTER, CENTER);
            switch (_type_l) {
                case 0:
                    rect(c_pave+MAILLE*zoom_x/4, l_pave+MAILLE*zoom_y/4, MAILLE*zoom_x/2, MAILLE*zoom_y/2);
                    fill(NOIR);
                    text(str(_label_c), c_pave+MAILLE*zoom_x/2, l_pave+MAILLE*zoom_y/2);
                    break;
                case 1:
                    rect(c_pave+MAILLE*zoom_x/8, l_pave+MAILLE*zoom_y/8, 3*MAILLE*zoom_x/4, 3*MAILLE*zoom_y/4);
                    fill(NOIR);
                    text(str(_label_c), c_pave+MAILLE*zoom_x/2, l_pave+MAILLE*zoom_y/2);
                    break;           
            }        
            noStroke();
        }
    }
    ////////////////////////////////////////// recherche connecteur /////////////////////////////////////
    //---------------------------------------- recherche_connecteur() -----------------------------------
    void recherche_connecteur(boolean _depart) {
        if (itineraire_demande || zone_recherchee) {
            int   c_mini     = 0;
            int   c_maxi     = c_max;
            int   l_mini     = 0;
            int   l_maxi     = 2*l_max;
            float distance   = 1000F;                                                                                                     //  comme on cherche un minimum => on part de loin (de 1000)
            int   memo_c     = 0;
            int   memo_l     = 0;
            int   memo_lames = 0;
            int   memo_cote  = 0;
            PVector mouse  = new PVector(mouseX, mouseY);
            for (int c = c_mini; c < c_maxi; c++) {
                for (int l = l_mini; l < l_maxi; l++) {
                    paveCL = tco.paves[c][l];
                    if (paveCL != null) {                                                                                                 //  on ne recherche que des pavés non nuls
                        for (int i = 0; i < 2; i++) {                                                                                     //  origine et extremite
                            for (int j = 0; j < paveCL.ordre; j++) {                                                                      //  autant de formes que de formes dans le pave
                                trouve = false;
                                recherche_pave_demande(paveCL, i, j);                                                                     //  recherche des pavés avec un retrait ou un signal ou un butoir
                                if (paveCL.bon_pave) {                                                                                    //  le pavé courant est un bon pavé
                                    //----------------------------- recherche du pavé mitoyen (pave_CL) du pavé en cours (paveCL) ----------------------------------------------------------                                                                                                                          
                                    for (int _c = c_mini; _c < c_maxi; _c++) {
                                        if (trouve) { break; }                                                                            //  on vient de trouver le connecteur mitoyen : on sort de la première boucle
                                        for (int _l = l_mini; _l < l_maxi; _l++) {
                                            if (trouve) { break; }                                                                        //  on vient de trouver le connecteur mitoyen : on sort de la deuxième boucle
                                            pave_CL = paves[_c][_l];
                                            if (pave_CL != null) {                                                                        //  on ne recherche que des pavés mitoyens non nuls
                                                if (!(c == _c && l == _l)) {                                                              //  on ne prend pas le meme pave et le mitoyen est un bon pavé
                                                    for (int lames = 0; lames < pave_CL.ordre; lames++) {                                 //  pour toutes les positions des lames
                                                        if (PVector.dist(paveCL.connecteur[i][j], pave_CL.connecteur[0][lames]) < 1.1) {  //  ----- on trouve un connecteur origine
                                                            recherche_pave_mitoyen(pave_CL, 0, lames);
                                                            if (pave_CL.bon_pave) {                                                       //  on mémorise si ce sont tous les deux des bons pavés
                                                                trouve     = true;
                                                                memo_cote  = 0;
                                                                memo_lames = lames;
                                                                memo_c     = _c;
                                                                memo_l     = _l;
                                                            }
                                                        } else {
                                                            if (PVector.dist(paveCL.connecteur[i][j], pave_CL.connecteur[1][lames]) < 1.1) {        //  ----- on trouve un connecteur extremite
                                                                recherche_pave_mitoyen(pave_CL, 1, lames);
                                                                if (pave_CL.bon_pave) {                                                   //  on mémorise si ce sont tous les deux des bons pavés
                                                                    trouve     = true;
                                                                    memo_cote  = 1;
                                                                    memo_lames = lames;
                                                                    memo_c     = _c;
                                                                    memo_l     = _l;
                                                                }
                                                            }
                                                        }                            
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    //----------------------------- recherche du pavé le plus proche et de son mitoyen -----------------------------------
                                    if (int(100*PVector.dist(paveCL.connecteur[i][j], mouse)) < int(100*distance) && trouve) {
                                        distance       = PVector.dist(paveCL.connecteur[i][j], mouse);
                                        //---------------------- calcul de la distance à la souris de l'autre connecteur de chaque pavé ----------------------------
                                        if (paveCL.appareil_de_voie || paveCL.type == 2) {                                                //  on n'a pas à choisir l'orientation quand le suivant est un appareil de voie ou un butoir
                                            choix_CL(_depart, c, l, i, j, memo_c, memo_l, memo_cote);
                                        } else {
                                            if (pave_CL.appareil_de_voie || pave_CL.type == 2) {                                          //  on n'a pas à choisir l'orientation quand le suivant est un appareil de voie ou un butoir
                                                choixCL(_depart, c, l, i, memo_c, memo_l, memo_cote, memo_lames);
                                            } else {
                                                PVector mouse_d = new PVector(mouse.x-paveCL.connecteur[i][j].x, mouse.y-paveCL.connecteur[i][j].y, 0);
                                                float   angle = mouse_d.heading();                                                        //  "heading" donne l'angle par rapport à l'horizontale pour séparer les 4 cas
                                                int retrait_en_x, retrait_en_y;
                                                if (i == 0) {
                                                    retrait_en_x = int(10*(paveCL.base0[0].x-paveCL.base12[0].x)+.5);                     //  0 -> 0, 1 -> 10, 0.707 -> 7
                                                    retrait_en_y = int(10*(paveCL.base0[0].y-paveCL.base12[0].y)+.5);
                                                } else {
                                                    retrait_en_x = int(10*(paveCL.base1[0].x-paveCL.base13[0].x)+.5);
                                                    retrait_en_y = int(10*(paveCL.base1[0].y-paveCL.base13[0].y)+.5);
                                                }
                                                if (retrait_en_y == 0) {                                                                  //  on a un retrait vertical
                                                    if (angle > HALF_PI || angle < -HALF_PI) {
                                                        choixCL(_depart, c, l, i, memo_c, memo_l, memo_cote, memo_lames); 
                                                    } else {
                                                        choix_CL(_depart, c, l, i, j, memo_c, memo_l, memo_cote);
                                                    }
                                                }
                                                if (retrait_en_x == 0) {                                                                  //  on a un retrait horizontal
                                                    if (angle < 0) {
                                                        choixCL(_depart, c, l, i, memo_c, memo_l, memo_cote, memo_lames); 
                                                    } else {
                                                        choix_CL(_depart, c, l, i, j, memo_c, memo_l, memo_cote);
                                                    }
                                                }
                                                if (retrait_en_x == retrait_en_y) {                                                       // on a un retrait suivant la première diagonale
                                                    if (angle > 3F*QUARTER_PI || angle < -QUARTER_PI) {
                                                        choixCL(_depart, c, l, i, memo_c, memo_l, memo_cote, memo_lames); 
                                                    } else {
                                                        choix_CL(_depart, c, l, i, j, memo_c, memo_l, memo_cote);
                                                    }
                                                }
                                                if (retrait_en_x == -retrait_en_y) {                                                      //  on a un retrait suivant la deuxième diagonale
                                                    if (angle > QUARTER_PI || angle < -3F*QUARTER_PI) {
                                                        choixCL(_depart, c, l, i, memo_c, memo_l, memo_cote, memo_lames); 
                                                    } else {
                                                        choix_CL(_depart, c, l, i, j, memo_c, memo_l, memo_cote);
                                                    }
                                                }
                                            }
                                            cherche_arrivee    = true;                                                                    //  on sait tout du départ : passons à l'arrivée
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            //--------------------------------- prolongement au depart si la zone occupee est sur plusieurs zones ----------------------
            if (_depart) {
                Pave pave = tco.paves[iti[0][0]][iti[0][1]];                                                                              //  pave_depart donne par la position donnée par la souris (cas normal)
                if (pave.occupe) {                                                                                                        //  si le pavé de départ n'est pas occupé, on n'a rien à prolonger
                    iti[0][2] = iti[0][0];
                    iti[0][4] = iti[0][1];
                    train = pupitre.trains[pave.numero_train1];
                    if (train != null) {                                                                                                  //  s'il y a un train
                        if (train.iti_train != null) {                                                                                    //  ce test ne sert qu'au debut, puisqu'il n'y a pas d'itinéraire
                            //------------------------------ comparaison des orientations d'itinéraires ------------------                            
                            boolean entrees_identiques = false;
                            int     compteur_paves     = -1;
                            for (Pave pave0 : train.iti_train.paves_composant_iti) {
                                compteur_paves++;
                                if (pave == pave0) {
                                    if (PVector.dist(pave.connecteur[iti[0][5]][0], 
                                                     pave0.connecteur[train.iti_train.entree_pave[compteur_paves]][0]) < 1.1) {
                                        entrees_identiques = true;                                                                        //  cotes identiques : la zone occupée est dans le même sens que le futur itinéraire
                                    }
                                    break;
                                }
                            }
                            for (Itineraire iti0 : tous_iti) {                                                                            //  dans tous les itinéraires
                                if (iti0.paves_composant_iti.contains(pave)) {                                                            //  on cherche l'itinéraire qui contient le premier pavé du futur itinéraire
                                    if (entrees_identiques) {                                                                             //  si les entrées sont identiques
                                        Pave pave0 = iti0.paves_composant_iti.get(0);                                                     //  simplification d'écriture
                                            depart     = pave0.connecteur[1-iti0.entree_pave[0]][0];                                      //  le pavé départ est le pave0, côté 1-entree_pave
                                            c_depart   = pave0.c;
                                            l_depart   = pave0.l;
                                            iti[0][0]  = c_depart;
                                            iti[0][1]  = l_depart;
                                            iti[0][5]  = iti0.entree_pave[0];                                                             //  le coté de départ est entrée_pave
                                    } else {
                                        Pave pave0 = iti0.paves_composant_iti.get(iti0.paves_composant_iti.size()-1);                     //  simplification d'écriture
                                            depart    = pave0.connecteur[iti0.entree_pave[iti0.paves_composant_iti.size()-1]][0];         //  le pavé départ est le pave0, côté entree_pave
                                            c_depart  = pave0.c;
                                            l_depart  = pave0.l;
                                            iti[0][0] = c_depart;
                                            iti[0][1] = l_depart;
                                            iti[0][5] = 1-iti0.entree_pave[iti0.paves_composant_iti.size()-1];                            //  le coté de départ est 1-entrée_pave
                                    }
                                    break;
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    //--------------------------------------- choixCL() ----------------------------------------------------------
    void choixCL(boolean _depart, int _c, int _l, int _i, int _memo_c, int _memo_l, int _memo_cote, int _memo_lames) {
        if (_depart) {
            c_trouve    = _c;                                                                                                             //  c_trouve et l_trouve ...
            l_trouve    = _l;                                                                                                             //  ... c'est le point vraiment choisi (sert uniquement pour zone_recherchee)
            Pave pave_cible_oppose_au_train = paveCL.pave_cible_zone[1-_i];                                                               //  "pave_cible_oppose_au_train", c'est le pave_cible_zone en allant vers 1-i (puisque le train va vers i)
            int cote_cible = pave_cible_oppose_au_train.cote_cible_zone[1-_i];                                                            //  en allant dans le sens (1-i), sur le pave_cible_zone
            depart        = pave_cible_oppose_au_train.connecteur[1-cote_cible][0];                                                       //  le point de depart de l'itinéraire, c'est le point de la zone le plus en amont du train, dans le sens oppose au cote cible
            c_depart      = pave_cible_oppose_au_train.c;                                                                   
            l_depart      = pave_cible_oppose_au_train.l;
            iti[0][0]     = c_depart;                                                                                                     //  on memorise le premier pavé (pour les itinéraires)
            iti[0][1]     = l_depart;
            iti[0][5]     = cote_cible;                                                                                                   //  cette fois, on va du cote du cible de depart
            pave_feu_noir = paveCL;                                                                                                       //  le pavé dont le feu sera noir : le premier feu rencontre par le train
            cote_feu_noir = _i;                                                                                                           //  cote i (le sens de déplacement du train)
        } else {
            autre          = pave_CL.connecteur[_memo_cote][_memo_lames];                                                                 //  le mitoyen du pavé selectionne
            c_autre        = _memo_c;
            l_autre        = _memo_l;
            Pave pave_cible_sens_train = paveCL.pave_cible_zone[_i];
            int  cote_cible = pave_cible_sens_train.cote_cible_zone[_i];
            arrivee       = pave_cible_sens_train.connecteur[cote_cible][0];
            c_arrivee     = pave_cible_sens_train.c;
            l_arrivee     = pave_cible_sens_train.l;            
            pave_feu_noir = pave_cible_sens_train;
            cote_feu_noir = _i;
        }
    }
    //--------------------------------------- choix_CL() ---------------------------------------------------------
    void choix_CL(boolean _depart, int _c, int _l, int _i, int _j, int _memo_c, int _memo_l, int _memo_cote) {
        if (_depart) {
            c_trouve    = _memo_c;                                                                                                        //  c_trouve et l_trouve...
            l_trouve    = _memo_l;                                                                                                        //  ... c'est le point vraiment choisi (sert uniquement pour zone_recherchee)
            Pave pave_cible_oppose_au_train = pave_CL.pave_cible_zone[1-_memo_cote];                                                      //  "pave_cible_oppose_au_train", c'est le pave_cible_zone en allant vers 1-i (puisque le train va vers i)
            int cote_cible = pave_cible_oppose_au_train.cote_cible_zone[1-_memo_cote];                                                    //  en allant dans le sens (1-i), sur le pave_cible_zone
            depart        = pave_cible_oppose_au_train.connecteur[1-cote_cible][0];                                                       //  le point de depart de l'itinéraire, c'est le point de la zone le plus en amont du train, dans le sens oppose au cote cible
            c_depart      = pave_cible_oppose_au_train.c;
            l_depart      = pave_cible_oppose_au_train.l;
            iti[0][0]     = c_depart;                                                                                                     //  on memorise le premier pavé (pour les itinéraires)
            iti[0][1]     = l_depart;
            iti[0][5]     = cote_cible;                                                                                                   //  cette fois, on va du cote du cible de depart
            pave_feu_noir = pave_CL;                                                                                                      //  le pavé dont le feu sera noir : le premier feu rencontre par le train
            cote_feu_noir = _memo_cote;                                                                                                   //  cote i (le sens de déplacement du train)
        } else {
            autre          = paveCL.connecteur[_i][_j];                                                                                   //  le mitoyen du pavé selectionne
            c_autre        = _c;
            l_autre        = _l;
            Pave pave_cible_sens_train = pave_CL.pave_cible_zone[_memo_cote];
            int  cote_cible = pave_cible_sens_train.cote_cible_zone[_memo_cote];
            arrivee       = pave_cible_sens_train.connecteur[cote_cible][0];
            c_arrivee     = pave_cible_sens_train.c;
            l_arrivee     = pave_cible_sens_train.l;            
            pave_feu_noir = pave_CL;
            cote_feu_noir = _memo_cote;
        }
    }
    //---------------------------------- recherche_pave_demande() ----------------------------------------------------------
    void recherche_pave_demande(Pave _pave, int _cote, int _forme) {
        _pave.bon_pave = false;
        if ((_pave.connecteur[_cote][_forme].z == 1 && !_pave.appareil_de_voie) || _pave.cible[_cote] || _pave.type == 2) {
            _pave.bon_pave = true;
        }
    }
    //---------------------------------- recherche_pave_mitoyen() ----------------------------------------------------------
    void recherche_pave_mitoyen(Pave _pave, int _cote, int _forme) {
        _pave.bon_pave = false;
        if ((_pave.connecteur[_cote][_forme].z == 1) || _pave.cible[_cote] || _pave.butoir[_cote] || _pave.appareil_de_voie) {
            _pave.bon_pave = true;
        }
    }
    //////////////////////////////////////////////////////////// signaux ///////////////////////////////////////////////////////////////////////////////////
    //---------------------------------------------------------- mise à jour signaux() ---------------------------------------------------------------------
    void maj_signaux() {
        for (Pave pave_depart : tous_paves) {                                                                                             //  on calcule tous les suivants de signaux et suivant sur la meme zone
            for (int cote = 0; cote < 2; cote++) {
                pave_depart.pave_cible_zone[cote]       = null;                                                                           //  qu'il y ait ou non une cible au départ, on cherche les cibles
                pave_depart.cote_cible_zone[cote]       = -1;
                pave_depart.trouve_cible[cote]          = false;
                if (pave_depart.cible[cote]) {                                                                                            //-----  on part d'un signal
                    pave_depart.pave_signal_suiv[cote]  = null;
                    pave_depart.cote_signal_suiv[cote]  = -1;
                    //--------------------- signal zone -------------------
                    pave_depart.pave_signal_zone[cote]  = pave_depart;
                    pave_depart.cote_signal_zone[cote]  = cote;
                    //--------------------- signal suivant --------------------
                    vitesse_maxi                        = 1000;                                                                           //  on part de 1000 car on cherche un minimum
                    presence_pave_occupe                = false;
                    signal_mitoyen(pave_depart.connecteur[cote][0], pave_depart, cote, pave_depart, cote, true);                          //  on cherche le signal suivant du signal_zone avec "true" parce qu'on part d'une cible
                } else {                                                                                                                  //----- on ne part pas d'un signal
                    pave_depart.pave_signal_zone[cote]  = null;
                    pave_depart.cote_signal_zone[cote]  = -1;
                    signal_mitoyen(pave_depart.connecteur[cote][pave_depart.lames], pave_depart, cote, pave_depart, cote, false);         //  on cherche le signal de la zone avec "false" parce qu'on ne part pas d'une cible
                }
            }
        }
        //-------------------------------------------- mise au CARRE si pas de signal suivant -----------------------------------------------
        for (Pave pave0 : tous_paves) {
            for (int cote = 0; cote < 2; cote++) {
                Pave pave_signal_suivant = pave0.pave_signal_suiv[cote];                                                                  //  on simplifie l'ecriture du pavé signal suivant
                if (pave_signal_suivant == null || pave0.butoir[cote] || pave0.carre_manuel[cote] == 1) {                                            //  signal suivant est null OU le pavé est un butoir OU on est sur un carré manuel
                                                                                if(pave0.c == 36 && pave0.l == 120) { println("SIGNAL : carre_manuel =", pave0.c, pave0.l); }
                    if (pave0.manoeuvre == 0) {
                        pave0.code_signal[cote]    = CARRE;
                        pave0.couleur_feu[cote]    = ROUGE;
                    } else {
                        pave0.code_signal[cote]    = CARRE_VIOLET;
                        pave0.couleur_feu[cote]    = VIOLET;
                    }
                    if (!pave0.feu_noir[cote]) {
                        pave0.feu_clignotant[cote] = false;
                    }
                }
            }
        }
        //---------------------------------------------- mise à jour des A, R et RR --------------------------------------------------------------
        for (Pave pave0 : tous_paves) {
            for (int cote = 0; cote < 2; cote++) {
                Pave pave_signal_suivant = pave0.pave_signal_suiv[cote];                                                                  //  on simplifie l'ecriture du pavé signal suivant
                if (pave0.code_signal[cote] != SEMAPHORE && pave0.code_signal[cote] != CARRE 
                 && pave0.code_signal[cote] != CARRE_VIOLET && pave0.code_signal[cote] != SEMAPHORE_CLI) {
                    int code_signal_suivant  = pave_signal_suivant.code_signal[pave0.cote_signal_suiv[cote]];                             //  on simplifie l'ecriture du signal suivant
                    if (code_signal_suivant == SEMAPHORE || code_signal_suivant == CARRE|| code_signal_suivant == CARRE_VIOLET) {         //  on calcule alors les AVERTISSEMENTS
                        pave0.code_signal[cote]    = AVERTISSEMENT;
                        pave0.couleur_feu[cote]    = JAUNE;
                        if (!pave0.feu_noir[cote]) {
                            pave0.feu_clignotant[cote] = false;
                        }
                    } else {
                        if (code_signal_suivant == RAPPEL_RALENTISSEMENT) {                                                               //  si le signal suivant (du bon cote) est un ralentissement 30, on met RR30                        
                            pave0.code_signal[cote]    = RALENTISSEMENT;
                            pave0.couleur_feu[cote]    = JAUNE;
                            if (!pave0.feu_noir[cote]) {
                                pave0.feu_clignotant[cote] = false;
                            }
                        }
                        if (code_signal_suivant == RAPPEL_RALENTISSEMENT_CLI) {                                                           //  si le signal suivant (du bon cote) est un ralentissement 60, on met RR60                                                
                            pave0.code_signal[cote]    = RALENTISSEMENT_CLI;
                            pave0.couleur_feu[cote]    = JAUNE;
                            if (!pave0.feu_noir[cote] ) {
                                pave0.feu_clignotant[cote] = true;
                            }
                        }
                    }
                }
            }
        }
    }    
    //------------------------------- signal_mitoyen() -------------------------------------------------------------------
    void signal_mitoyen(PVector _connecteur_courant, Pave _pave_courant, int _cote_courant, Pave _pave_depart, int _cote_depart, boolean _true_suivant_false_zone) {
        trouve = false;        
        for (Pave pave_boucle : tous_paves) {
            if (trouve) { break; }                                                                                                        //  on vient de trouver le signal suivant : on sort de la deuxieme boucle
            if (!(pave_boucle == _pave_courant || pave_boucle == _pave_depart)) {                                                         //  on ne prend pas le meme pave, ni le pavé de depart
                int lames = pave_boucle.lames;                                                                                            //  variable locale de la position des lames du pavé teste (pour simplifier l'ectiture)
                if (_cote_courant == 0) {
                    if (PVector.dist(_connecteur_courant, pave_boucle.connecteur[0][lames]) < 1.1) {                                      //  on trouve un connecteur origine   (= [0])
                        if (pave_boucle.type == 2) {                                                                                      //  au passage, on met butoir à true si le pavé suivant est de type 2
                             _pave_courant.butoir[_cote_courant] = true;
                        }
                        connecteur_suivant_trouve(_pave_courant, _cote_courant, pave_boucle, 1, _pave_depart, _cote_depart, _true_suivant_false_zone);                                
                    } else {
                        if (PVector.dist(_connecteur_courant, pave_boucle.connecteur[1][lames]) < 1.1) {                                  //  on trouve un connecteur extremite (= [1])
                            if (pave_boucle.type == 2) {                                                                                  //  au passage, on met butoir à true si le pavé suivant est de type 2
                                 _pave_courant.butoir[_cote_courant] = true;
                            }
                            connecteur_suivant_trouve(_pave_courant, _cote_courant, pave_boucle, 0, _pave_depart, _cote_depart, _true_suivant_false_zone);
                        }
                    }                            
                } else {
                    if (PVector.dist(_connecteur_courant, pave_boucle.connecteur[0][lames]) < 1.1) {                                      //  on trouve un connecteur origine   (= [0])
                        if (pave_boucle.type == 2) {                                                                                      //  au passage, on met butoir à true si le pavé suivant est de type 2
                            _pave_courant.butoir[_cote_courant] = true;
                        }
                        connecteur_suivant_trouve(_pave_courant, _cote_courant, pave_boucle, 1, _pave_depart, _cote_depart, _true_suivant_false_zone);
                    } else {
                        if (PVector.dist(_connecteur_courant, pave_boucle.connecteur[1][lames]) < 1.1) {                                  //  on trouve un connecteur extremite (= [1])
                            if (pave_boucle.type == 2) {                                                                                  //  au passage, on met butoir à true si le pavé suivant est de type 2
                                 _pave_courant.butoir[_cote_courant] = true;
                            }
                            connecteur_suivant_trouve(_pave_courant, _cote_courant, pave_boucle, 0, _pave_depart, _cote_depart, _true_suivant_false_zone);                                
                        }
                    }
                }
            }
        }
        if (!trouve) {                                                                                                                    //  on n'a trouvé aucun connecteur mitoyen, donc ni signal, ni cible
            if (_pave_courant.cible[_cote_courant] && !_pave_depart.trouve_cible[_cote_depart] ) {                                        //  si le pavé courant a une cible et qu'on a pas touvé de cible au pavé départ, du coté départ
                _pave_depart.pave_cible_zone[_cote_depart] = _pave_courant;                                                               //  le pavé courant est le pave_cible_zone
                _pave_depart.cote_cible_zone[_cote_depart] = _cote_courant;                                                               //  le cote_courant est le cote_cible_zone
                _pave_depart.trouve_cible[_cote_depart]    = true;                                                                        //  dans ces conditions, on peut dire qu'on a trouvé une cible au pavé départ
            }
        }
    }
    //---------------------------------------------------------- connecteur_suivant_trouve() -----------------------------------------------------------
    void connecteur_suivant_trouve(Pave _pave_courant, int _cote_courant, Pave _pave_boucle, int _cote_boucle, Pave _pave_depart, int _cote_depart, boolean _true_suivant_false_zone) {
        if (_pave_boucle.occupe && !_pave_boucle.ID_zone.equals(_pave_depart.ID_zone)) {                                                  //  on va compter les paves occupés jusqu'au prochain signal
            presence_pave_occupe = true;                                                                                                  //  s'il y en a au moins 1, on a SEMAPHORE
        }
        int lames = _pave_boucle.lames;                                                                                                   //  pour simplifier l'ecriture                                      
        if (!(lames == 0                                                                                                                  //  si  NON (position directe sur l'appareil de voie
          || (lames == 2 && _pave_boucle.type == 17)                                                                                      //          (position directe sur TJS (l'autre positions) 
          || (lames == 2 && _pave_boucle.type == 18))) {                                                                                  //          (position directe sur TJD (l'autre positions) 
            vitesse_maxi = min(vitesse_maxi, _pave_boucle.vitesse_deviee);                                                                //  alors    on garde la vitesse mini en position deviee
        }
        if (_pave_courant.cible[_cote_courant] && !_pave_depart.trouve_cible[_cote_depart] ) {                                            //  si le pavé courant a une cible et qu'on a pas touvé de cible au pavé départ, du coté départ
            _pave_depart.pave_cible_zone[_cote_depart] = _pave_courant;                                                                   //  le pavé courant est le pave_cible_zone
            _pave_depart.cote_cible_zone[_cote_depart] = _cote_courant;                                                                   //  le cote_courant est le cote_cible_zone
            _pave_depart.trouve_cible[_cote_depart]    = true;
        }
        if (_pave_boucle.cible[_cote_boucle] && !_pave_depart.trouve_cible[_cote_depart] ) {                                              //  si le pavé boucle a une cible et qu'on a pas touvé de cible au pavé départ, du coté départ
            _pave_depart.pave_cible_zone[_cote_depart] = _pave_boucle;                                                                    //  le pavé boucle est le pave_cible_zone
            _pave_depart.cote_cible_zone[_cote_depart] = _cote_boucle;                                                                    //  le cote_boucle est le cote_cible_zone
            _pave_depart.trouve_cible[_cote_depart]    = true;
        }
        trouve = true;                                                                                                                    //  on a trouve un connecteur. Mais ce n'est pas fini...
        if (_pave_boucle.cible[_cote_boucle] || _pave_boucle.butoir[_cote_boucle]) {                                                      //  si le cote_courant a une cible visible, c'est la bonne
            if (_true_suivant_false_zone) {                                                                                               //-------- si on partait d'une cible, on a trouve le signal suivant
                _pave_depart.pave_signal_suiv[_cote_depart]  = _pave_boucle;                                                              //  on recupere les coordonnées du pavé suivant
                _pave_depart.cote_signal_suiv[_cote_depart]  = _cote_boucle;                                                              //  on recupere le bon cote du signal suivant
                if (_pave_depart.manoeuvre == 0) {                                                                                        //--- si on est sur une VP
                    if (_pave_boucle.manoeuvre == 0) {                                                                                    //  si on ne va pas vers une zone de manoeuvre
                        _pave_depart.feu_si_devie[_cote_depart]  = vitesse_maxi;                                                          //  on recupere la vitesse maxi de voie deviee
                        switch (vitesse_maxi) {
                            case 1000:
                                _pave_depart.code_signal[_cote_depart]        = VOIE_LIBRE;
                                _pave_depart.couleur_feu[_cote_depart]        = VERT;
                                if (!_pave_depart.feu_noir[_cote_depart]) {
                                    _pave_depart.feu_clignotant[_cote_depart] = false;
                                }
                                break;
                            case 30:
                                _pave_depart.code_signal[_cote_depart]        = RAPPEL_RALENTISSEMENT;
                                _pave_depart.couleur_feu[_cote_depart]        = JAUNE;
                                if (!_pave_depart.feu_noir[_cote_depart]) {
                                    _pave_depart.feu_clignotant[_cote_depart] = false;
                                }
                                break;
                            case 60:
                                _pave_depart.code_signal[_cote_depart]        = RAPPEL_RALENTISSEMENT_CLI;
                                _pave_depart.couleur_feu[_cote_depart]        = JAUNE;
                                if (!_pave_depart.feu_noir[_cote_depart]) {
                                    _pave_depart.feu_clignotant[_cote_depart] = true;
                                }
                                break;
                            case 120:  //  à decrire (c'est aussi lie à des panneaux fixes)
                                break;
                        }
                        if (presence_pave_occupe) {                                                                                       // si on a trouve un pavé occupe dans les paves suivants, on met à SEMAPHORE (qui effacera ce qu'il y avait si besoin)
                            if (!_pave_depart.rouge_clignotant[_cote_depart]) {
                                _pave_depart.code_signal[_cote_depart]        = SEMAPHORE;
                                _pave_depart.couleur_feu[_cote_depart]        = ROUGE;
                                if (!_pave_depart.feu_noir[_cote_depart]) {
                                    _pave_depart.feu_clignotant[_cote_depart] = false;
                                }
                            } else {
                                _pave_depart.code_signal[_cote_depart]        = SEMAPHORE_CLI;
                                _pave_depart.couleur_feu[_cote_depart]        = ROUGE;
                                _pave_depart.feu_clignotant[_cote_depart]     = true;
                            }
                        }
                    } else {                                                                                                              //  si on va vers une zone de manouvre
                        _pave_depart.code_signal[_cote_depart]        = MANOEUVRE;
                        _pave_depart.couleur_feu[_cote_depart]        = BLANC;
                        if (!_pave_depart.feu_noir[_cote_depart]) {
                            _pave_depart.feu_clignotant[_cote_depart] = false;
                        }
                    }
                } else {                                                                                                                  //--- si on est sur une VS
                    _pave_depart.code_signal[_cote_depart]        = MANOEUVRE;
                    _pave_depart.couleur_feu[_cote_depart]        = BLANC;
                    if (!_pave_depart.feu_noir[_cote_depart]) {
                        _pave_depart.feu_clignotant[_cote_depart] = false;
                    }
                }
            } else {                                                                                                                      //-------- si on ne partait pas d'une cible, on a trouve le signal de zone
                _pave_depart.pave_signal_zone[_cote_depart]   = _pave_boucle;                                                             //  on a trouve le signal de la zone. Un par cote [2]
                _pave_depart.cote_signal_zone[_cote_depart]   = _cote_boucle;
            }
        } else {                                                                                                                          //  il n'y a pas de cible en [1] : on continue en [0] en cherchant un [0]
            signal_mitoyen(_pave_boucle.connecteur[_cote_boucle][lames], _pave_boucle, _cote_boucle, _pave_depart, _cote_depart, _true_suivant_false_zone);   //  on est en [0], on continue avec l'autre connecteur [1] du pavé en cours
        }                                
    }
    //////////////////////////////////////////// itineraires /////////////////////////////////////////////////////////////////////////////////
    //---------------------------------- recherche_itineraires() ------------------------------------------------------
    void recherche_itineraires(PVector _depart, int _c_depart, int _l_depart) {
        connecteur_mitoyen(_depart, _c_depart, _l_depart);                                                                                //  on cherche le connecteur origine de l'appareil de voie mitoyen du connecteur de départ
        trouve   = false;                                                                                                                 //  quand on en est là, c'est qu'on est sorti de la récursivité (ligne précédente)
        if (!tout_teste) {                                                                                                                //  si non n'a pas tout testé
            for (int i = 0; i < INDEX_MAX; i++) {
                pave = tco.paves[iti[i][0]][iti[i][1]];
                if (pave != null && !(iti[i][0] == 0 && iti[i][1] == 0)) {
                    courant = i;
                }
            }
            if (!tco.paves[iti[courant][0]][iti[courant][1]].appareil_de_voie) {
                Itineraire itineraire    = new Itineraire();
                itineraire.enregistrement();
                tous_iti_tempo.add(itineraire);
                itineraire.numero_train = 1000;
                itineraire.pave_premier = itineraire.pave_debut;                                                                          //  on garde le tout premier pavé de l'itinéraire, fixe car pave_debut varie avec les effacements
            }
            numero_iti_debut = -1;                                                                                                        //  numero_iti_debut est le point de départ de la boucle qui affiche les iti_tempo en SABLE
            for (Itineraire iti0 : tous_iti_tempo) {
                if (iti0.numero_train == 1000) {
                    break;
                }
                numero_iti_debut++;
            }
        }
    }    
    //-------------------------------------- connecteur_mitoyen() ----------------------------------
    void connecteur_mitoyen(PVector _connecteur_courant, int _c, int _l) {
        max_recherche++;
        if (fini) { return; }
        if ((PVector.dist(_connecteur_courant, depart) < 1.1 && retour))  {                                                               //  on est au point de départ en reculant : On ressort et on teste d'autres solutions
            tout_teste = true;
            fini = true;                                                                                                                  //  on sort
            return;
        }
        if (index == 0 && retour)  {                                                                                                      //  on a reculé jusqu'en haut du tableau : On sort
            tout_teste = true;
            fini = true;                                                                                                                  //  on sort
            return;
        }
        if (PVector.dist(_connecteur_courant, arrivee) < 1.1 && _c == c_arrivee && _l == l_arrivee && !retour)  {                         //  on est au point d'arrivée en marche avant : on sort et on teste d'autres solutions
            connecteur_retour = autre;                                                                                                    //  si c'est un butoir, on repart du butoir lui même (de l'autre côté du connecteur courant)
            c_retour          = c_autre;
            l_retour          = l_autre;
            index++;
            max_index = max(max_index, index);
            fini = true;                                                                                                                  //  on sort
            return;
        }
        trouve = false;
        for (int c = 0; c < c_max; c++) {
            if (trouve) { break; }                                                                                                        //  on vient de trouver le connecteur mitoyen : on sort de la deuxieme boucle
            for (int l = 0; l < 2*l_max; l++) {
                if (trouve) { break; }                                                                                                    //  on vient de trouver le connecteur mitoyen : on sort de la première boucle
                paveCL = paves[c][l];
                if (paveCL != null) {
                    if (!((c == _c && l == _l) || (c == c_depart && l == l_depart))) {                                                    //  on ne prend pas le meme pave... ni le pavé de depart
                        if (!paveCL.choisi || (paveCL.choisi && retour)) {                                                                //  il ne faut pas que le pavé soit déjà choisi, sauf si on recule
                            for (int lames = 0; lames < paveCL.ordre; lames++) {
                                if (PVector.dist(_connecteur_courant, paveCL.connecteur[0][lames]) < 1.1) {                               //  on trouve un connecteur origine
                                    trouve = true;
                                    if (PVector.dist(_connecteur_courant, arrivee) > 1.1) {                                               //---------- si on n'est pas SUR le connecteur arrivée
                                        if (retour) {                                                                                     //--- si on recule                                                                      
                                            paveCL.choisi = false;
                                            for (int j = 0; j < 6; j++) {
                                                iti[index][j] = 0;
                                            }
                                            index = max(0, index-1);
                                            connecteur_suivant(paveCL.connecteur[0][lames], c, l);                                        //  on continue avec le suivant du connecteur origine
                                        } else {                                                                                          //--- si on avance
                                            paveCL.choisi = true;
                                            index++;
                                            max_index = max(max_index, index);
                                            iti[index][0] = c;
                                            iti[index][1] = l;
                                            premier[index]       = paveCL.connecteur[0][lames];                                           //  on garde en memoire le premier connecteur par lequel on entre dans un pave
                                            connecteur_suivant(paveCL.connecteur[0][lames], c, l);                                        //  on continue avec le suivant du connecteur origine
                                        }
                                    } else {                                                                                              //---------- si on est SUR le connecteur arrivée
                                        if (c == c_arrivee && l == l_arrivee) {                                                           //  si on est DANS le pave arrivée
                                            if (!retour) {                                                                                //---  si on arrive en marche avant, c'est normal et on sort
                                                connecteur_retour = arrivee;
                                                c_retour = c_arrivee;
                                                l_retour = l_arrivee;
                                                fini = true;
                                            } else {                                                                                      //  si on arrive en marche arrière, on recule, ce n'est pas une arrivée
                                                paveCL.choisi = false;
                                                for (int j = 0; j < 6; j++) {
                                                    iti[index][j] = 0;
                                                }
                                                index = max(0, index-1);
                                                connecteur_suivant(_connecteur_courant, c, l);                                            //  on rebondit sur l'arrivée pour chercher d'autres possibilités
                                            }
                                        } else {                                                                                          //  on est sur le bon connecteur arrivée, mais pas du bon côté : on recule
                                            retour = true;
                                            connecteur_suivant(_connecteur_courant, c, l);
                                        }
                                    }
                                } else {
                                    if (PVector.dist(_connecteur_courant, paveCL.connecteur[1][lames]) < 1.1) {                           //  on trouve un connecteur extremite
                                        trouve = true;
                                        if (PVector.dist(_connecteur_courant, arrivee) > 1.1) {                                           //---------- on est LOIN du connecteur arrivee
                                            if (retour) {                                                                                 //--- si on recule
                                                paveCL.choisi = false;
                                                for (int j = 0; j < 6; j++) {
                                                    iti[index][j] = 0;
                                                }
                                                index = max(0, index-1);
                                                connecteur_suivant(paveCL.connecteur[1][lames], c, l);                                    //  on continue avec le suivant du connecteur extremite
                                            } else {                                                                                      //--- si on avance
                                                paveCL.choisi = true;
                                                index++;
                                                max_index = max(max_index, index);
                                                iti[index][0] = c;
                                                iti[index][1] = l;
                                                premier[index]       = paveCL.connecteur[1][lames];                                       //  on garde en memoire le premier connecteur par lequel on entre dans un pave
                                                connecteur_suivant(paveCL.connecteur[1][lames], c, l);                                    //  on continue avec le suivant du connecteur extremite
                                            }
                                        } else {                                                                                          //----------- on est PROCHE du connecteur arrivee
                                            if (c == c_arrivee && l == l_arrivee) {                                                       //  on est SUR le connecteur arrivée
                                                if (!retour) {                                                                            //  si on arrive en marche avant, c'est normal et on sort
                                                    connecteur_retour = arrivee;
                                                    c_retour = c_arrivee;
                                                    l_retour = l_arrivee;
                                                    fini = true;
                                                } else {                                                                                  //  si on arrive en marche arrière, on recule, ce n'est pas une arrivée
                                                    paveCL.choisi = false;
                                                    for (int j = 0; j < 6; j++) {
                                                        iti[index][j] = 0;
                                                    }
                                                    index = max(0, index-1);
                                                    connecteur_suivant(_connecteur_courant, c, l);                                        //  on rebondit sur l'arrivée pour chercher d'autres possibilités
                                                }
                                            } else {                                                                                      //  on est sur le bon connecteur arrivée, mais pas du bon côté : on recule
                                                retour = true;
                                                connecteur_suivant(_connecteur_courant, c, l);
                                            }
                                        }
                                    }
                                }                            
                            }
                        }
                    }
                }
            }
        }
        if (!trouve) {                                                                                                                    //  on n'a pas trouve de mitoyen ( ex : butoir ou le pavé mitoyen est déjà choisi)
            paves[_c][_l].choisi = false;
            retour = true;  
            connecteur_suivant(_connecteur_courant, _c, _l);                                                                              //  on repart dans l'autre sens (du connecteur d'ou l'on vient)
        }
    }
    //---------------------------------------- connecteur_suivant() ------------------------------------------------------------------------------
    void connecteur_suivant(PVector _connecteur_courant, int _c, int _l) {
        if (fini) { return; }
        pave = paves[_c][_l];
        //------------------------- calcul d' iti[index][4] = nombre de possibilites de la première entrée -----------
        int lame[]  =  new int[3];
        lame[0]     =  0;
        lame[1]     =  0;
        lame[2]     =  0;
        int rang    =  -1;
        for (int lames = 0; lames < pave.ordre; lames++) {                                                                                //  on cherche parmi tous les connecteurs du pavé combien sont egaux à premier_connecteur
            if (PVector.dist(premier[index], pave.connecteur[0][lames]) < 1.1) {
                rang++;                                                                                                                   //      on sait alors si on est entre en pointe ou en talon
                lame[rang] = lames;                                                                                                       //      on sait aussi, dans le cas d'une aiguille en talon, quelle est la position des lames
            } else {
                if (PVector.dist(premier[index], pave.connecteur[1][lames]) < 1.1) {
                    rang++;                                                                                                               //      on sait alors si on est entre en pointe ou en talon
                    lame[rang] = lames;                                                                                                   //      on sait aussi, dans le cas d'une aiguille en talon, quelle est la position des lames
                }
            }
        }
        iti[index][4] = rang+1;                                                                                                           //  on a ici iti[index][4], le nombre de possibilites de la première entree
        //---------------------------- calcul de multi = nombre de possibilites du connecteur courant -------------
        int multi   =  0;
        for (int lames = 0; lames < pave.ordre; lames++) {                                                                                //  recherche de multi (nombre de possibilites du connecteur courant)
            if (PVector.dist(_connecteur_courant, pave.connecteur[0][lames]) < 1.1) {
                multi++;
            } else {
                if (PVector.dist(_connecteur_courant, pave.connecteur[1][lames]) < 1.1) {
                    multi++;
                }
            }
        }
        //------------------------------------------- trouver le connecteur suivant -----------------------------
        if (retour) {
            if (iti[index][4] == 1) {                                                                                                     //  retour d'un pavé à forme unique ou d'un appareil de voie d'abord pris en talon
                if (PVector.dist(_connecteur_courant, pave.connecteur[0][lame[0]]) < 1.1) {                                         
                    sortie = pave.connecteur[1][lame[0]];                                                                                 //  sortie est simplement le connecteur oppose
                    iti[index][5] = 0;
                } else {
                    if (PVector.dist(_connecteur_courant, pave.connecteur[1][lame[0]]) < 1.1) {
                        sortie = pave.connecteur[0][lame[0]];                                                                             //  sortie est simplement le connecteur oppose
                        iti[index][5] = 1;
                    }
                }
            } else {                                                                                                                      //  on retourne sur un appareil de voie pris d'abord en pointe 
                if ((multi == 1 && iti[index][4] > 1)                                                                                     //  1er cas : on est sur une entrée unique (ex : aiguille en talon) 
                 || (multi > 1)) {                                                                                                        //  2eme cas : on est sur une entrée multiple (ex : TJS, TJD)
                    sortie = premier[index];                                                                                              //      on repart de la pointe
                    iti[index][2]++;                                                                                                      //      à ce stade, on change le rang de la position des lames
                    if (iti[index][2] < iti[index][4]) {                                                                                  //  on a encore des choix à tester (rang < nb de positions maxi de la pointe)
                        if (PVector.dist(sortie, pave.connecteur[0][lame[iti[index][2]]]) < 1.1) {
                            retour = false;
                            sortie = pave.connecteur[1][lame[iti[index][2]]];                                                             //  sortie est le connecteur oppose, avec la nouvelle position des lames
                            iti[index][5] = 0;
                        } else {
                            if (PVector.dist(sortie, pave.connecteur[1][lame[iti[index][2]]]) < 1.1) {
                                retour = false;
                                sortie = pave.connecteur[0][lame[iti[index][2]]];                                                         //  sortie est le connecteur oppose, avec la nouvelle position des lames
                                iti[index][5] = 1;
                            }
                        }
                        iti[index][3] = lame[iti[index][2]];                                                                              //  on transforme le rang en position des lames
                    } else {                                                                                                              //  on a epuise tous les choix : on continue à reculer depuis premier[]
                        sortie = premier[index];
                    }
                }
            }
        } else {
            if ((multi == 1 && iti[index][4] > 1)                                                                                         //  1er  cas : une raquette construite avec une aiguille ou un triple
             || (multi == 2 && iti[index][2] == 2)) {                                                                                     //  2eme cas : une raquette construite avec une TJD ou une TJS
                retour = true;
                sortie = _connecteur_courant;                                                                                             //  on rebondit sur l'appareil de voie
            } else {                                                                                                                      //  cas normal
                if (PVector.dist(_connecteur_courant, pave.connecteur[0][lame[0]]) < 1.1) {                                         
                    sortie = pave.connecteur[1][lame[0]];                                                                                 //  sortie est le connecteur oppose
                    iti[index][5] = 0;                                                                                                    //  on entre dans le pavé par le connecteur 0
                } else {
                    if (PVector.dist(_connecteur_courant, pave.connecteur[1][lame[0]]) < 1.1) {
                        sortie = pave.connecteur[0][lame[0]];                                                                             //  sortie est le connecteur oppose
                        iti[index][5] = 1;                                                                                                //  on entre dans le pavé par le connecteur 1
                    }
                }
                iti[index][2] = 0;                                                                                                        //  c'est le premier passage en avant
                iti[index][3] = lame[0];                                                                                                  //  on transforme le rang en position des lames
            }
        }
        connecteur_mitoyen(sortie, _c, _l);
    }
}
